#include <cstdio>
#include <algorithm>
#include <string>
#include <vector>
#include <map>

#include "testlib.h"

using namespace std;

const int START_ID = 3;

void p(int a, int b, int c, int d) {
    static int id = START_ID;
    static char filename[10];

    sprintf(filename, "%d", id);
    ++id;
    FILE * fout = fopen(filename, "wt");
    fprintf(fout, "%d %d %d %d\n", a, b, c, d);
    fclose(fout);
}

vector<int> Gen4Different()
{
    static const int S = 9;
    static const int values[S] = { 6, 7, 8, 9, 10, 11, 12, 13, 14 };
    vector<int> perm(values, values + S);
    shuffle(perm.begin(), perm.end());
    return vector<int>(perm.begin(), perm.begin() + 4);
}

static size_t minJokers = 0;
static size_t maxJokers = 1;


void ByPattern(const string& pattern)
{
    vector<int> v = Gen4Different();
    map<char, int> index;
    vector<int> ret(pattern.length());
    int currentIndex = 0;
    size_t jokers = 0;
    for (size_t i = 0; i < pattern.length(); ++i) {
        if (pattern[i] == '0') {
            ret[i] = 0;
            ++jokers;
            continue;
        }
        if (index.count(pattern[i]) == 0) {
            index[pattern[i]] = currentIndex++;
        }
        ret[i] = v[index[pattern[i]]];
    }
    if (jokers >= minJokers && jokers <= maxJokers)
        p(ret[0], ret[1], ret[2], ret[3]);
}

inline void g(const string& pattern) {
    ByPattern(pattern);
}

void GenTests(string & pattern, size_t used = 0)
{
    static const char charSet[] = { 'x', 'y', 'z', 't' };
    static const char joker = '0';

    if (pattern.length() == 4) {
        ByPattern(pattern);
        return;
    }
    for (size_t i = 0; i < used + 1; ++i) {
        pattern += charSet[i];
        GenTests(pattern, used + (i == used));
        pattern.erase(pattern.end() - 1);
    }

    pattern += joker;
    GenTests(pattern, used);
    pattern.erase(pattern.end() - 1);
}

int main(int argc, char * argv[])
{
    registerGen(argc, argv);
    string genStr;

    GenTests(genStr);
    p(0, 0, 0, 0);

    minJokers = 2;
    maxJokers = 3;
    GenTests(genStr);

    return 0;
}
